﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Markup;
using System.Printing;
using System.Windows.Xps;
using System.Windows.Xps.Packaging;
using System.IO;

namespace BuildXpsInMemory
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            printDocument.Click += new RoutedEventHandler(printDocument_Click);
            writeDocument.Click += new RoutedEventHandler(writeDocument_Click);
        }

        void writeDocument_Click(object sender, RoutedEventArgs e)
        {
            XpsDocument xpsDoc = new XpsDocument(@"C:\Users\ian\Documents\Pluralsight\WpfCourse\OsloDemos\Output.xps",
                FileAccess.Write);

            XpsDocumentWriter dw = XpsDocument.CreateXpsDocumentWriter(xpsDoc);

            FixedDocument fd = BuildXps();
            dw.Write(fd);

            xpsDoc.Close();
        }

        void printDocument_Click(object sender, RoutedEventArgs e)
        {
            FixedDocument fd = BuildXps();

            PrintDocumentImageableArea area = null;
            XpsDocumentWriter dw = PrintQueue.CreateXpsDocumentWriter(ref area);

            dw.Write(fd);
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            FixedDocument fd = BuildXps();

            viewer.Document = fd;
        }

        private FixedDocument BuildXps()
        {
            FixedDocument doc = new FixedDocument();
            for (int page = 1; page < 5; ++page)
            {
                FixedPage fpage = new FixedPage();

                TextBlock tb = new TextBlock();
                tb.Text = "Page " + page;
                tb.FontSize = 80;
                tb.FontFamily = new FontFamily("Parchment");

                fpage.Children.Add(tb);
                FixedPage.SetLeft(tb, 20);
                FixedPage.SetTop(tb, 20);


                PageContent pc = new PageContent();
                ((IAddChild) pc).AddChild(fpage);

                doc.Pages.Add(pc);
            }

            return doc;
        }
    }
}
