﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace BackgroundWorkerDemo
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        BackgroundWorker bgWorker;

        SlowThing thing = new SlowThing();
        public Window1()
        {
            InitializeComponent();

            bgWorker = new BackgroundWorker();
            bgWorker.DoWork += new DoWorkEventHandler(bgWorker_DoWork);
            bgWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(bgWorker_RunWorkerCompleted);
        }

        void bgWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            // Runs on UI thread

            string result = e.Result.ToString();
            textBlock1.Text = result;
        }

        void bgWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            // Runs on worker thread.
            string result = thing.Data;

            e.Result = result;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            bgWorker.RunWorkerAsync();
        }
    }
}
